Commit d720518f by Jason Merrill Committed by Jason Merrill

lock-and-run.sh: Check for process existence rather than timeout.

	* lock-and-run.sh: Check for process existence rather than timeout.

Matthias Klose noted that on less powerful targets, a link might take more
than 5 minutes; he mentions a figure of 3 hours for an LTO link.  So this
patch changes the timeout to a check for whether the locking process still
exists.  If the lock exists in an erroneous state (no pid file or can't
signal the pid) for 30 sec, steal it.

From-SVN: r277277
parent 0bfdd2d4
2019-10-21 Jason Merrill <jason@redhat.com>
* lock-and-run.sh: Check for process existence rather than timeout.
2019-10-21 Jozef Lawrynowicz <jozef.l@mittosystems.com>
* expr.c (expand_expr_real_2): Don't widen constant op1 when expanding
#! /bin/sh
# Shell-based mutex using mkdir.
# Shell-based mutex using mkdir. This script is used in make to prefer
# serialized execution to avoid consuming too much RAM. If reusing it,
# bear in mind that the lock-breaking logic is not race-free, so disable
# it in err() if concurrent execution could cause more serious problems.
self=`basename $0`
lockdir="$1" prog="$2"; shift 2 || exit 1
# Remember when we started trying to acquire the lock.
count=0
touch lock-stamp.$$
trap 'rm -r "$lockdir" lock-stamp.$$' 0
err () {
if test -f $lockdir/lock-$1.$$; then
echo "$self: *** (PID $$) removing stale $lockdir" >&2
rm -rf $lockdir
# Possible variant for uses where races are more problematic:
#echo "$self: *** (PID $$) giving up, maybe rm -r $lockdir" >&2
#exit 42
else
touch $lockdir/lock-$1.$$
fi
}
until mkdir "$lockdir" 2>/dev/null; do
# Say something periodically so the user knows what's up.
if [ `expr $count % 30` = 0 ]; then
# Reset if the lock has been renewed.
if [ -n "`find \"$lockdir\" -newer lock-stamp.$$`" ]; then
touch lock-stamp.$$
count=1
# Steal the lock after 5 minutes.
elif [ $count = 300 ]; then
echo removing stale $lockdir >&2
rm -r "$lockdir"
# Check for valid lock.
if pid=`cat $lockdir/pid 2>/dev/null` && kill -0 $pid 2>/dev/null; then
echo "$self: (PID $$) waiting $count sec to acquire $lockdir from PID $pid" >&2
elif test -z "$pid"; then
echo "$self: (PID $$) cannot read $lockdir/pid" >&2
err nopid
else
echo waiting to acquire $lockdir >&2
echo "$self: (PID $$) cannot signal $lockdir owner PID $pid" >&2
err dead
fi
fi
sleep 1
count=`expr $count + 1`
done
trap 'rm -rf "$lockdir"' 0
echo $$ > $lockdir/pidT && mv $lockdir/pidT $lockdir/pid
echo "$self: (PID $$) acquired $lockdir after $count seconds" >&2
echo $prog "$@"
$prog "$@"
......
Markdown is supported
0% or
You are about to add 0 people to the discussion. Proceed with caution.
Finish editing this message first!
Please register or to comment